function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var MyAlgo = _interopDefault(require('@randlabs/myalgo-connect'));
var algosdk = _interopDefault(require('algosdk'));

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

// A type of promise-like that resolves synchronously and supports only one observer

const _iteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.iterator || (Symbol.iterator = Symbol("Symbol.iterator"))) : "@@iterator";

const _asyncIteratorSymbol = /*#__PURE__*/ typeof Symbol !== "undefined" ? (Symbol.asyncIterator || (Symbol.asyncIterator = Symbol("Symbol.asyncIterator"))) : "@@asyncIterator";

// Asynchronously call a function and send errors to recovery continuation
function _catch(body, recover) {
	try {
		var result = body();
	} catch(e) {
		return recover(e);
	}
	if (result && result.then) {
		return result.then(void 0, recover);
	}
	return result;
}

var styles = {"AlgoButton":"_1E3Mb","AlgoSendButton":"_uMOg7"};

var _excluded = ["asset", "recipient", "amount", "note", "myAddress", "wallet", "context", "returnTo"],
    _excluded2 = ["wallet", "context", "returnTo"];
var Pipeline = /*#__PURE__*/function () {
  function Pipeline() {}

  Pipeline.init = function init() {
    return new MyAlgo();
  };

  Pipeline.connect = function connect(wallet) {
    try {
      return Promise.resolve(_catch(function () {
        return Promise.resolve(wallet.connect()).then(function (accounts) {
          var item1 = accounts[0];
          item1 = item1["address"];
          return item1;
        });
      }, function (err) {
        console.error(err);
      }));
    } catch (e) {
      return Promise.reject(e);
    }
  };

  Pipeline.send = function send(address, amt, note, sendingAddress, wallet) {
    if (amt === void 0) {
      amt = 1;
    }

    if (note === void 0) {
      note = "Transaction note";
    }

    try {
      var algodToken = {
        'X-API-Key': 'dmONugeHOX2DC8nDb3v8m6Bo9cI3WHbW6Ntt4QCZ'
      };
      var algodServer = "https://mainnet-algorand.api.purestake.io/ps2";
      var algodPort = "";
      return Promise.resolve(function () {
        try {
          return Promise.resolve(_catch(function () {
            var algodClient = new algosdk.Algodv2(algodToken, algodServer, '');
            return Promise.resolve(algodClient.getTransactionParams()["do"]()).then(function (params) {
              var txn = _extends({}, params, {
                type: 'pay',
                from: sendingAddress,
                to: address,
                amount: amt,
                note: new Uint8Array(Buffer.from(note))
              });

              return Promise.resolve(wallet.signTransaction(txn)).then(function (signedTxn) {
                return Promise.resolve(algodClient.sendRawTransaction(signedTxn.blob)["do"]()).then(function () {
                  return signedTxn.txID;
                });
              });
            });
          }, function (err) {
            console.error(err);
          }));
        } catch (e) {
          return Promise.reject(e);
        }
      }()).then(JSON.stringify);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  Pipeline.sendASA = function sendASA(address, amt, note, sendingAddress, wallet, asaNumb) {
    if (amt === void 0) {
      amt = 1;
    }

    if (note === void 0) {
      note = "Transaction note";
    }

    try {
      var algodToken = {
        'X-API-Key': 'dmONugeHOX2DC8nDb3v8m6Bo9cI3WHbW6Ntt4QCZ'
      };
      var algodServer = "https://mainnet-algorand.api.purestake.io/ps2";
      var algodPort = "";
      return Promise.resolve(function () {
        try {
          return Promise.resolve(_catch(function () {
            var algodClient = new algosdk.Algodv2(algodToken, algodServer, '');
            return Promise.resolve(algodClient.getTransactionParams()["do"]()).then(function (params) {
              var txn = _extends({}, params, {
                type: 'axfer',
                assetIndex: asaNumb,
                from: sendingAddress,
                to: address,
                amount: amt,
                note: new Uint8Array(Buffer.from(note))
              });

              return Promise.resolve(wallet.signTransaction(txn)).then(function (signedTxn) {
                return Promise.resolve(algodClient.sendRawTransaction(signedTxn.blob)["do"]()).then(function () {
                  return signedTxn.txID;
                });
              });
            });
          }, function (err) {
            console.error(err);
          }));
        } catch (e) {
          return Promise.reject(e);
        }
      }()).then(JSON.stringify);
    } catch (e) {
      return Promise.reject(e);
    }
  };

  return Pipeline;
}();
var AlgoSendButton = function AlgoSendButton(_ref) {
  var asset = _ref.asset,
      recipient = _ref.recipient,
      amount = _ref.amount,
      note = _ref.note,
      myAddress = _ref.myAddress,
      wallet = _ref.wallet,
      context = _ref.context,
      returnTo = _ref.returnTo,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  return /*#__PURE__*/React.createElement("button", _extends({}, props, {
    className: styles.AlgoSendButton,
    onClick: function onClick() {
      if (asset == 'Algorand') {
        Pipeline.send(recipient, parseInt(amount), note, myAddress, wallet).then(function (data) {
          if (typeof data !== 'undefined') {
            var object = {};
            object[returnTo] = data;
            context.setState(object);
          }
        });
      } else {
        Pipeline.sendASA(recipient, parseInt(amount), note, myAddress, wallet, parseInt(asset)).then(function (data) {
          if (typeof data !== 'undefined') {
            var object = {};
            object[returnTo] = data;
            context.setState(object);
          }
        });
      }
    }
  }), "Send");
};
var AlgoButton = function AlgoButton(_ref2) {
  var wallet = _ref2.wallet,
      context = _ref2.context,
      returnTo = _ref2.returnTo,
      props = _objectWithoutPropertiesLoose(_ref2, _excluded2);

  return /*#__PURE__*/React.createElement("button", _extends({}, props, {
    size: "24px",
    className: styles.AlgoButton,
    onClick: function onClick() {
      Pipeline.connect(wallet).then(function (accounts) {
        var data = {};
        data[returnTo] = accounts;
        context.setState(data);
      });
    }
  }), "Connect to MyAlgo");
};

exports.AlgoButton = AlgoButton;
exports.AlgoSendButton = AlgoSendButton;
exports.Pipeline = Pipeline;
//# sourceMappingURL=index.js.map
